unit TestIO;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, WACapi;

type
  TdlgTestIO = class(TForm)
    btClose: TBitBtn;
    panDI: TPanel;
    panDO: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    tmWriteDO: TTimer;
    panErroDI: TPanel;
    panErroDO: TPanel;
    btLoopDO: TBitBtn;
    btReset: TBitBtn;
    btReadDI: TBitBtn;
    btLoopDI: TBitBtn;
    btEscrita: TBitBtn;
    edVal: TEdit;
    tmReadDI: TTimer;
    panLoopDI: TPanel;
    panLoopDO: TPanel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    procedure tmWriteDOTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btLoopDOClick(Sender: TObject);
    procedure btResetClick(Sender: TObject);
    procedure btReadDIClick(Sender: TObject);
    procedure btEscritaClick(Sender: TObject);
    procedure btLoopDIClick(Sender: TObject);
    procedure tmReadDITimer(Sender: TObject);
  private
    { Private declarations }
    procedure ReadDI;
    procedure WriteDO(val: word);
    Function  ToStrBin(v: word): string;
  public
    { Public declarations }
  end;

var
  dlgTestIO: TdlgTestIO;

implementation

{$R *.DFM}

const ContLoop: word = 0;

procedure TdlgTestIO.FormCreate(Sender: TObject);
begin
  ContLoop:= 0;
end;

procedure TdlgTestIO.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tmReadDI.Enabled:= false;
  tmWriteDO.Enabled:= false;
end;

Function TdlgTestIO.ToStrBin(v: word): string;
  var i: integer; s: string;
begin
  s:= '';
  for i:= 1 to 8 do
  begin
    s:= Char (Ord('0') + (v mod 2)) + s;
    v := v div 2;
  end;
  Insert(' ', s, 5);
  ToStrBin:= s;
end;

procedure TdlgTestIO.tmWriteDOTimer(Sender: TObject);
begin
  {Escrita na saida digital}
  WriteDO(ContLoop);

  if ContLoop = $ff then
    ContLoop:= 0
  else
    Inc(ContLoop);
end;

procedure TdlgTestIO.tmReadDITimer(Sender: TObject);
begin
  {Leitura da entrada digital}
  ReadDI;
end;

procedure TdlgTestIO.btLoopDOClick(Sender: TObject);
begin
  {Habilita/Desabilita loop de escrita}
  tmWriteDO.Enabled:= not tmWriteDO.Enabled;
  if tmWriteDO.Enabled then
    panLoopDO.Caption:= 'Loop ON'
  else
    panLoopDO.Caption:= 'Loop OFF';
end;

procedure TdlgTestIO.btLoopDIClick(Sender: TObject);
begin
  tmReadDI.Enabled:= not tmReadDI.Enabled;
  if tmReadDI.Enabled then
    panLoopDI.Caption:= 'Loop ON'
  else
    panLoopDI.Caption:= 'Loop OFF';
end;

procedure TdlgTestIO.btResetClick(Sender: TObject);
begin
  ContLoop:= 0;
end;

procedure TdlgTestIO.btReadDIClick(Sender: TObject);
begin
  {Executa leitura da entrada digital}
  ReadDI;
end;

procedure TdlgTestIO.ReadDI;
  var val: word;
begin
  {Leitura da entrada digital}
  if not ReadAC2122DigitalPort(val) then
    panErroDI.Caption:= 'Erro DI';

  val:= Lo(val);
  panDI.Caption:= ToStrBin(val)+ ' [' + Format('%.3d',[val]) + ']';
end;

procedure TdlgTestIO.WriteDO (val: word);
begin
  {Escrita na Saida Digital}
  val:= lo(val);
  if not WriteAC2122DigitalPort(val) then
    panErroDO.Caption:= 'Erro DO';
  panDO.Caption:= ToStrBin(val)+ ' [' + Format('%.3d',[val]) + ']';
end;

procedure TdlgTestIO.btEscritaClick(Sender: TObject);
  var w: word; i: integer;
begin
  Val(edVal.Text, w, i);
  if i = 0 then
    ContLoop:= Lo(w);

  edVal.Text:= IntToStr(ContLoop);

  WriteDO(ContLoop);
end;

end.

